<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <NuxtLayout name="default">
        <div class="catalog-page">

            <!-- sidebar navigation teleported to template -->
            <SidebarNav :nav="navItems" :title="'Catalog'" />

            <!-- <FiltersTop :sortOptions="sortOptions">
                <a href="#" class="button button-default button-black rounded" title="Add"
                    @click="showCreateDatasetModal = true">
                    <i class="icon-add"></i> Add Dataset
                </a>
                <div class="filters-top-totals"><b>33 Domains</b> related to this dataset</div>
            </FiltersTop> -->

            <Datatable :data="data">
                <button class="button-secondary orange" @click="showCreateDatasetModal = true">
                    New Quality Rule
                </button>
                <div class="filters-top-totals"><b>11 Quality Rules</b> available</div>
            </Datatable>

        </div>

        <ClientOnly>
            <Teleport to="#modals-container">
                <ModalsCreateDataset v-if="showCreateDatasetModal" @toggle="close" />
            </Teleport>
        </ClientOnly>

        <div class="container">
            <div class="offset-xl-1 col-xl-10 mt-160">
                <BannersBannerCta :banners="BannerCta" />
            </div>
        </div>

    </NuxtLayout>
</template>
<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';
import type NavItemI from '~/interfaces/navItem';
import slide1 from '@/assets/images/slide1.png';
import type sliderItemI from '~/interfaces/sliderItem';

useHead({
    title: 'Quality Rules - DATAMITE'
});

const showCreateDatasetModal = ref(false);

const close = () => {
    console.log(2);
    showCreateDatasetModal.value = false;
};

// make the function close available to emit in other components
defineExpose({ close });

const data = ref<DataTableI>({
    options: {
        tableName: 'quality-table',
        detailsPath: '/quality-rules/',
        allowCheckRow: true,
        favourites: true,
        previewComponent: ''
    },
    columns: [
        {
            id: 1,
            name: 'overall',
            label: 'Overall',
            filterType: 'text',
            width: '120px',
            combineColumn: 'type',
            renderComponent: 'TableColumnsQuality'
        },
        {
            id: 2,
            name: 'name',
            label: 'Name',
            filterType: 'select',
            width: '120px'
        },
        {
            id: 3,
            name: 'dimension',
            label: 'Dimension',
            filterType: 'select',
            width: '100px'
        },
        {
            id: 4,
            name: 'description',
            label: 'Description',
            width: '145px'
        },
        {
            id: 5,
            name: 'domain',
            label: 'Domain',
            filterType: 'select',
            width: '160px'
        },
        {
            id: 6,
            name: 'owner',
            label: 'Owner',
            filterType: 'select',
            renderComponent: 'UserProfile',
            width: '140px'
        },
        {
            id: 6,
            name: 'edited_at',
            label: 'Edited at',
            width: '70px'
        },
        {
            id: 7,
            name: 'actions',
            label: 'Actions',
            width: '112px',
            hideLabel: true
        }
    ],
    rows: [
        {
            id: 1,
            overall: 99,
            name: 'Rule Name Goes Here',
            dimension: 'Accuracy',
            description: 'Lorem ipsum dolor sit amet, consectetur...',
            domain: 'Data Science/Analytics',
            owner: '',
            edited_at: '2022-01-01 22:43',
            actions: ''
        },
        {
            id: 2,
            overall: 99,
            name: 'Rule Name Goes Here',
            dimension: 'Accuracy',
            description: 'Lorem ipsum dolor sit amet, consectetur...',
            domain: 'Data Science/Analytics',
            owner: '',
            edited_at: '2022-01-01 22:43',
            actions: ''
        },
        {
            id: 3,
            overall: 99,
            name: 'Rule Name Goes Here',
            dimension: 'Accuracy',
            description: 'Lorem ipsum dolor sit amet, consectetur...',
            domain: 'Data Science/Analytics',
            owner: '',
            edited_at: '2022-01-01 22:43',
            actions: ''
        }
    ]
});

const viewDefault = () => {
    console.log('show default home page');
}

const dummyClick = () => {
    console.log('dummyClick');
}

const navItems = ref<NavItemI[]>([
    {
        label: 'All',
        icon: 'list',
        action: viewDefault
    },
    {
        label: 'Combine Datasets',
        icon: 'chrome',
        action: dummyClick
    },
    {
        label: 'Recently Viewed',
        icon: 'clock',
        action: dummyClick
    },
    {
        label: 'Highlighted',
        icon: 'favourite',
        action: dummyClick
    },
    {
        label: 'Your Catalog',
        icon: 'loading',
        action: dummyClick
    }
]);

// const sortOptions = ref(['Last modified first', 'Last modified last', 'Option 3']);

const BannerCta = ref<sliderItemI[]>([
    {
        id: 1,
        title: 'Have a question or doubts?',
        text: 'Check our FAQs and Documentation',
        button_text: 'Faqs and Documentation',
        button_link: 'https://www.google.com',
        media_type: 1,
        media_url: slide1,
        template: 1,
    }
])

</script>